#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire700eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight7004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight7004xi = {
                1:'-107x-142y-676z',
                2:'-107x-538y-434z',
                3:'-110x-242y-647z',
                4:'-118x-142y-675z',
                5:'-123x-470y-503z',
                6:'-123x-684y-76z',
                7:'-125x-242y-644z',
                8:'-130x-140y-673z',
                9:'-137x-535y-429z',
                10:'-13x-109y-691z',
                11:'-141x-241y-641z',
                12:'-142x-138y-671z',
                13:'-149x-468y-498z',
                14:'-154x-135y-669z',
                15:'-157x-238y-638z',
                16:'-159x-677y-69z',
                17:'-15x-692y-97z',
                18:'-166x-131y-667z',
                19:'-166x-531y-423z',
                20:'-173x-235y-636z',
                21:'-175x-464y-493z',
                22:'-178x-125y-664z',
                23:'-189x-230y-633z',
                24:'-190x-119y-662z',
                25:'-195x-526y-417z',
                26:'-195x-669y-62z',
                27:'-1x-96y-693z',
                28:'-201x-458y-488z',
                29:'-202x-113y-660z',
                30:'-205x-225y-630z',
                31:'-20x-115y-690z',
                32:'-214x-105y-658z',
                33:'-21x-465y-522z',
                34:'-21x-535y-450z',
                35:'-221x-218y-626z',
                36:'-224x-519y-412z',
                37:'-225x-96y-655z',
                38:'-227x-452y-483z',
                39:'-230x-658y-55z',
                40:'-236x-86y-653z',
                41:'-237x-210y-623z',
                42:'-246x-76y-650z',
                43:'-252x-510y-406z',
                44:'-253x-201y-620z',
                45:'-253x-443y-478z',
                46:'-256x-64y-647z',
                47:'-264x-646y-48z',
                48:'-266x-52y-645z',
                49:'-268x-192y-617z',
                50:'-274x-39y-642z',
                51:'-278x-433y-473z',
                52:'-27x-120y-688z',
                53:'-281x-500y-400z',
                54:'-283x-181y-613z',
                55:'-283x-25y-639z',
                56:'-297x-168y-610z',
                57:'-298x-631y-41z',
                58:'-29x-258y-756z',
                59:'-303x-422y-468z',
                60:'-309x-488y-395z',
                61:'-311x-155y-607z',
                62:'-324x-141y-603z',
                63:'-328x-409y-463z',
                64:'-330x-615y-34z',
                65:'-336x-474y-389z',
                66:'-337x-126y-600z',
                67:'-349x-110y-596z',
                68:'-352x-395y-457z',
                69:'-35x-125y-687z',
                70:'-360x-93y-592z',
                71:'-362x-597y-27z',
                72:'-363x-459y-383z',
                73:'-375x-379y-452z',
                74:'-389x-442y-377z',
                75:'-38x-230y-659z',
                76:'-393x-578y-20z',
                77:'-398x-362y-447z',
                78:'-414x-424y-371z',
                79:'-420x-343y-441z',
                80:'-423x-557y-13z',
                81:'-438x-404y-365z',
                82:'-441x-324y-436z',
                83:'-44x-130y-686z',
                84:'-452x-534y-6z',
                85:'-461x-302y-430z',
                86:'-462x-383y-359z',
                87:'-46x-468y-517z',
                88:'-479x-509y0z',
                89:'-480x-280y-425z',
                90:'-484x-360y-353z',
                91:'-497x-256y-419z',
                92:'-505x-336y-347z',
                93:'-50x-537y-445z',
                94:'-514x-232y-413z',
                95:'-51x-235y-657z',
                96:'-51x-692y-90z',
                97:'-525x-311y-341z',
                98:'-529x-206y-408z',
                99:'-53x-134y-684z',
                100:'-543x-179y-402z',
                101:'-544x-285y-335z',
                102:'-556x-152y-396z',
                103:'-561x-257y-329z',
                104:'-567x-123y-391z',
                105:'-576x-94y-385z',
                106:'-577x-229y-323z',
                107:'-584x-64y-379z',
                108:'-591x-199y-316z',
                109:'-604x-169y-310z',
                110:'-615x-138y-304z',
                111:'-63x-137y-683z',
                112:'-65x-238y-654z',
                113:'-6x-102y-692z',
                114:'-72x-470y-513z',
                115:'-73x-139y-681z',
                116:'-79x-538y-440z',
                117:'-80x-240y-652z',
                118:'-84x-141y-680z',
                119:'-87x-689y-83z',
                120:'-95x-142y-678z',
                121:'-95x-242y-649z',
                122:'-97x-471y-508z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire700eight4xi" usage = "target function for charge700eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire700eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE700EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE700EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE700EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE700EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE700EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight7004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE700EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE700EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE700EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight7004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight7004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE700EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE700EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE700EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire700eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  